package LeonMP3Encoder.Affichage;
import java.awt.*;
import javax.swing.*;

/**
Image sous forme d'un JPanel
*/
public class LeonImage extends JPanel 
{
	/**
	Image
	*/
	private ImageIcon img;      

	/**
	Constructeur
	@param file image
	*/
	public LeonImage(Image file) 
	{
		img = new ImageIcon(file);
		setPreferredSize(new Dimension(img.getIconWidth(),img.getIconHeight()));
		repaint(); 
	}
		
	/**
	Ordonne au programme de forcer un refresh
	*/
	public void paintComponent(Graphics g) 
	{
		super.paintComponent(g);
		if (img != null)
			if(getWidth()>img.getIconWidth())
				g.drawImage(img.getImage(), getDecalage(), 0, img.getIconWidth(), img.getIconHeight(), this);
			else
				g.drawImage(img.getImage(), 0, 0, img.getIconWidth(), img.getIconHeight(), this);
	}

	/**
	Recupere la valeur du decalage dans le conteneur de l'image
	@return decalage
	*/
	protected int getDecalage()
	{
		if(getWidth()>img.getIconWidth())
			return (int)(getWidth()-img.getIconWidth())/2;
		else
			return 0;
	}

	/**
	Renvoi l'image
	@return image
	*/
	public Image getImage()
	{
		return img.getImage();
	}
	
	public ImageIcon getImageIcon()
	{
		return img;
	}	
}