package LeonMP3Encoder.ComposantsGraphiques;

import LeonMP3Encoder.Encoder.*;
import LeonMP3Encoder.Affichage.*;
import LeonMP3Encoder.Interface.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class barJPanel extends JToolBar
{
	public static int BUTTON_ADD = 1;
	public static int BUTTON_REMOVE = 2;
	public static int BUTTON_CLEAR = 3;
	public static int BUTTON_COMPRESS = 4;
	public static int BUTTON_UNCOMPRESS = 5;
	public static int BUTTON_ALL = 6;

	private JButton add;
	private JButton remove;
	private JButton clear;
	private JButton compress;
	private JButton uncompress;
	private LeonMP3Encoder parent;
	
	public barJPanel(LeonMP3Encoder a)
	{
		init(a);
		initVar();
		initEvent();
		ajouter();
	}
	
	public void init(LeonMP3Encoder a)
	{
		parent = a;
		setLayout(new FlowLayout(FlowLayout.LEFT));
	}
	
	public void initVar()
	{
		LeonImage addImg = new LeonImage(Toolkit.getDefaultToolkit().getImage("/"+Evenements.getPath()+"../../../Imgs/Add.png"));
		LeonImage delImg = new LeonImage(Toolkit.getDefaultToolkit().getImage("/"+Evenements.getPath()+"../../../Imgs/Del.png"));
		LeonImage remImg = new LeonImage(Toolkit.getDefaultToolkit().getImage("/"+Evenements.getPath()+"../../../Imgs/Rem.png"));
		LeonImage mp3Img = new LeonImage(Toolkit.getDefaultToolkit().getImage("/"+Evenements.getPath()+"../../../Imgs/mp3.png"));
		LeonImage wavImg = new LeonImage(Toolkit.getDefaultToolkit().getImage("/"+Evenements.getPath()+"../../../Imgs/wav.png"));
		
		add 		= new JButton("Ajouter"		,addImg.getImageIcon());
		remove 		= new JButton("Retirer"		,delImg.getImageIcon());
		clear 		= new JButton("Vider"		,remImg.getImageIcon());
		compress 	= new JButton("Compresser"	,mp3Img.getImageIcon());
		uncompress 	= new JButton("Decompresser",wavImg.getImageIcon());	
	}
	
	public void bloquer( int composant, boolean etat)
	{
		if( composant == barJPanel.BUTTON_ADD )
			add.setEnabled(!etat);
		else if( composant == barJPanel.BUTTON_REMOVE )
			remove.setEnabled(!etat);
		else if( composant == barJPanel.BUTTON_CLEAR )
			clear.setEnabled(!etat);
		else if( composant == barJPanel.BUTTON_COMPRESS )
			compress.setEnabled(!etat);
		else if( composant == barJPanel.BUTTON_UNCOMPRESS )
			uncompress.setEnabled(!etat);
		else if( composant == barJPanel.BUTTON_ALL )
		{
			add.setEnabled			(!etat);
			remove.setEnabled		(!etat);
			clear.setEnabled		(!etat);
			compress.setEnabled		(!etat);
			uncompress.setEnabled	(!etat);			
		}
	}	
	
	public void initEvent()
	{
		add.addActionListener( new ActionListener ()
		{
			public void actionPerformed (ActionEvent ev )
			{
				String [] liste = Evenements.chooseFiles();
				parent.addFile( liste );
			}
		
		});
		
		remove.addActionListener( new ActionListener ()
		{
			public void actionPerformed (ActionEvent ev )
			{
				parent.removeSelected();
			}
		
		});		
		
		clear.addActionListener( new ActionListener ()
		{
			public void actionPerformed (ActionEvent ev )
			{
				parent.clear();
			}
		
		});
		
		compress.addActionListener( new ActionListener ()
		{
			public void actionPerformed (ActionEvent ev )
			{
				parent.compressFiles();
			}
		
		});
		
		uncompress.addActionListener( new ActionListener ()
		{
			public void actionPerformed (ActionEvent ev )
			{
				parent.uncompressFiles();
			}
		
		});			
	}
	
	public void ajouter()
	{
		add( add );
		add( remove );
		add( clear );
		add( new JSeparator() );
		add( compress );
		add( uncompress );
	}
}