package LeonMP3Encoder.ComposantsGraphiques;

import LeonMP3Encoder.Interface.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class optionJPanel extends JPanel
{
	public JTextField dir;
	public JTextField prefix;
	public JComboBox kb;	
	public JComboBox mode;
	public JComboBox enc;
	public JComboBox freq;	
	public JButton dirChoose;
	
	/**
	 * Constructeur d'un OptionJPanel
	 */
	public optionJPanel()
	{
		initVal();
		initEvent();
		init();
		ajouter();
	}
	
	/**
	 * Initialise les champs
	 */
	public void initVal()
	{
		dir 		= new JTextField(35);
		prefix		= new JTextField(35);
		kb 			= new JComboBox();		
		mode		= new JComboBox();
		enc			= new JComboBox();	
		freq		= new JComboBox();			
		dirChoose	= new JButton(Evenements.BrowseOption);
		
		for(int i=320;i>12;i-=16)
		{
			kb.addItem(Integer.toString(i));
			if(i>256)
				i-=32;
			if(i>160)
				i-=16;			
		}
		kb.setSelectedIndex(6);
		mode.addItem(Evenements.ModeOption1);
		mode.addItem(Evenements.ModeOption2);
		enc.addItem(Evenements.EncodOption1);
		enc.addItem(Evenements.EncodOption2);
		enc.addItem(Evenements.EncodOption3);
		freq.addItem("48");
		freq.addItem("32");
		freq.addItem("24");
		freq.addItem("16");
		freq.addItem("12");
		freq.addItem("8");
		
		dir.setText(Evenements.getUrl());
	}
	
	/**
	 * Initialise les events
	 */
	public void initEvent()
	{
		dirChoose.addActionListener( new ActionListener (){public void actionPerformed (ActionEvent ev ){dir.setText(Evenements.chooseDir());}});
	}
	
	/**
	 * Init les Layouts
	 */
	public void init()
	{
		TitledBorder title;
		title = BorderFactory.createTitledBorder(Evenements.OptionsOption);
		setBorder(title);
		setLayout(new FlowLayout());
	}
	
	/**
	 * Met en place l'interface
	 */
	public void ajouter()
	{
		JPanel total = new JPanel(new BorderLayout(5,5));
		JPanel grid1 = new JPanel(new GridLayout(1,2,5,5));
		JPanel grid2 = new JPanel(new GridLayout(2,1,5,5));			
		JPanel bord1 = new JPanel(new BorderLayout(5,5));
		JPanel bord2 = new JPanel(new BorderLayout(5,5));		
		JPanel bord3 = new JPanel(new BorderLayout(5,5));
		JPanel bord4 = new JPanel(new BorderLayout(5,5));		
		JPanel bord5 = new JPanel(new BorderLayout(5,5));	
	//	JPanel bord6 = new JPanel(new BorderLayout(5,5));	
		
		bord1.add(new JLabel(Evenements.KbsOption+" :"),BorderLayout.WEST);
		bord1.add(kb,BorderLayout.CENTER);
	//	bord6.add(new JLabel("Freq :"),BorderLayout.WEST);
	//	bord6.add(freq,BorderLayout.CENTER);		
		bord2.add(new JLabel(Evenements.ModeOption+" :"),BorderLayout.WEST);
		bord2.add(mode,BorderLayout.CENTER);
		bord5.add(new JLabel(Evenements.EncodOption+" :"),BorderLayout.WEST);
		bord5.add(enc,BorderLayout.CENTER);		
		bord3.add(new JLabel(Evenements.PathOption+" :"),BorderLayout.WEST);
		bord3.add(dir,BorderLayout.CENTER);
		bord3.add(dirChoose,BorderLayout.EAST);		
		bord4.add(new JLabel(Evenements.LabelOption+" :"),BorderLayout.WEST);
		bord4.add(prefix,BorderLayout.CENTER);
		
		grid1.add(bord1);
	//	grid1.add(bord6);		
		grid1.add(bord2);
		grid1.add(bord5);		
		grid2.add(bord3);
		grid2.add(bord4);
		
		total.add(grid1,BorderLayout.NORTH);
		total.add(grid2,BorderLayout.SOUTH);
		
		add(total);
	}
	
	/**
	 * renvoie le rep de destination
	 * @return repertoire de destination
	 */
	public String getDir()
	{
		return dir.getText()+"\\"+prefix.getText();
	}

	/**
	 * Renvoie les options de compression
	 * @return options de compressions
	 */
	public String getOptions(boolean mp3)
	{
		String options="";
		
	//	options+=" -s "+freq.getSelectedItem();
		
		if(mp3)
		{
			options+=" -b "+(String)kb.getSelectedItem();
			if(mode.getSelectedIndex()==1)
				options+=" -a";
			
			if(enc.getSelectedIndex()==0)
				options+=" -h";
			else if(enc.getSelectedIndex()==2)
				options+=" -f";			
		}
		
		return options;
	}
}



