package LeonMP3Encoder.Encoder;
import javax.swing.*;
import java.awt.*;
import LeonMP3Encoder.Affichage.LeonImage;
import LeonMP3Encoder.Interface.Evenements;

/**
 * Thread gerant l'affichage des fichiers en compression
 */
class myThread extends Thread
{
	int nombreFichiers;
	JFrame fenetre;
	JLabel label;
	
	/**
	 * Constructeur du thread
	 * @param nbrFichiers nombres de fichiers a compresser
	 */
	public myThread(int nbrFichiers)
	{
		nombreFichiers = nbrFichiers;
		label = new JLabel("0 "+Evenements.FileCompressOnEncoder+" "+nombreFichiers,SwingConstants.CENTER);
	}
	
	/**
	 * Lance le thread
	 */
	public void run() 
	{
		fenetre = new JFrame(Evenements.SoftName+" :: "+Evenements.InProgressEncoder);
		fenetre.setIconImage(new LeonImage(Toolkit.getDefaultToolkit().getImage(this.getClass().getResource(".").getPath().replace('/', '\\').replaceAll("%20", " ")+"../../../Imgs/icon.png")).getImage());
		fenetre.setSize(250,70);
		fenetre.setLocationRelativeTo(fenetre.getParent());
		fenetre.setResizable(false);
		fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fenetre.setLayout(new BorderLayout(5,5));
		fenetre.add(label,BorderLayout.CENTER);
		fenetre.setVisible(true);		
	}
	
	/**
	 * Change de Texte ecrit dans la fenetre
	 * @param i fichiers deja compresses
	 */
	public void setText( int i)
	{
		fenetre.remove(label);
		label = new JLabel(i+Evenements.FileCompressOnEncoder+" "+nombreFichiers,SwingConstants.CENTER);
		fenetre.add(label);
		fenetre.validate();
	}
	
	/**
	 * Fin de l'init
	 */
	public void end()
	{
		fenetre.setTitle(Evenements.SoftName +" :: "+ Evenements.EndProgressEncoder);
		fenetre.remove(label);
		label = new JLabel(Evenements.EndProgressEncoder,SwingConstants.CENTER);
		fenetre.add(label);	
		fenetre.validate();
	}
}

/**
 * Classe qui encode les fichiers
 * @author LeonSulivan
 */
class Encoder
{
	Process p;
	int iterateur=0;
	int nbrFichiers=0;
	myThread fenetre;
	
	/**
	 * Constructeur de l'encondeur
	 * @param cmds liste des fichiers a encoder
	 */
	public Encoder( String cmds )
	{
		compressFiles(cmds);
		try {UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());} 
		catch (Exception e) { e.printStackTrace();}
	}

	/**
	 * Lance la compression
	 * @param cmd liste des fichiers a compresser
	 */
	public void compressFiles(String cmd)
	{
		cmd = cmd.replace(",,,quote,,,","\"");	
		String [] tab = cmd.split(",,,separator,,,");
		nbrFichiers = tab.length;	
		
		fenetre = new myThread(nbrFichiers);
		fenetre.start();
		
		try 
		{
			for(iterateur=0;iterateur<tab.length;iterateur++)
			{
				Runtime r = Runtime.getRuntime();
				
				p = r.exec(tab[iterateur]+" --quiet");
				p.waitFor();
					
				fenetre.setText(iterateur+1);
				
			}
		}
		catch(Exception e)
		{
			System.out.println("erreur d'execution " + cmd + e.toString());
		} 
		
		fenetre.end();

	}
	
	/**
	 * Main
	 * @param args commandes externes
	 */
	public static void main( String [] args )
	{
		String arg="";
		for(String i:args)
			arg+=" "+i;
		new Encoder(arg);
	}
	
}